> For new integrations, EasyParcel recommends the NextGen API: https://developer.easyparcel.com/

# Market Rate Checking

> EasyParcel API · Malaysia · MarketPlace · version 1.4.0.0
> Page: https://developers.easyparcel.com/my/marketplace/market-rate-checking · Markdown: https://developers.easyparcel.com/my/marketplace/market-rate-checking.md · PDF: https://developers.easyparcel.com/pdf/Malaysia_MarketPlace_1.4.0.0.pdf

This enable market rate checking from all courier companies in EasyParcel platform. User need to provide sender and receiver address to check the market rate.

## Endpoint

- Method: `POST`
- Demo URL: `https://demo.connect.easyparcel.my/?ac=MPNormalRateCheckingBulk`
- Live URL: `https://connect.easyparcel.my/?ac=MPNormalRateCheckingBulk`
- Body: `application/x-www-form-urlencoded`. Nested fields use PHP `http_build_query` names, e.g. `bulk[0][pick_code]`.
- Action: `MPNormalRateCheckingBulk`

## Request parameters

### Request L1

| Parameter | Type | Required | Description |
| --- | --- | --- | --- |
| `authentication` | string(25) | Yes | Obtain from EasyParcel IT administrator |
| `api` | string(25) | Yes | Obtain from registered account. |
| `bulk` | array | Yes | (Refer to [Request L2](#request-l2)) |

### Request L2 · `bulk[]` {#request-l2}

| Parameter | Type | Required | Description |
| --- | --- | --- | --- |
| `pick_code` | string(10) | Yes | Sender's postcode. |
| `pick_state` | string(10) | Yes | Sender’s state |
| `pick_country` | string(2) | Yes | Sender's country (“MY”). |
| `send_code` | string(10) | Yes | Receiver's postcode. |
| `send_state` | string(10) | Yes | Receiver’s state |
| `send_country` | string(2) | Yes | Receiver's country (“MY”). |
| `weight` | double(8,2) | Yes | The weight of the parcel. |
| `width` | double(8,2) | Optional | The width of the parcel. |
| `length` | double(8,2) | Optional | The length of the parcel. |
| `height` | double(8,2) | Optional | The height of the parcel. |
| `date_coll` | date | Optional | Check the available pickup date. If the date is left empty, the default will be today’s date. Format : “YYYY-MM-DD” |

## Sample code

### PHP

```php
<?php
$domain = "https://demo.connect.easyparcel.my/?ac=";

$action = "MPNormalRateCheckingBulk";
$postparam = array(
    'authentication' => 'xxxxxx',
    'api' => 'xxxxxx',
    'bulk' => array(
        array(
            'pick_code' => '14300',
            'pick_state' => 'nt',
            'pick_country' => 'MY',
            'send_code' => '81100',
            'send_state' => 'jhr',
            'send_country' => 'MY',
            'weight' => '10',
            'width' => '0',
            'length' => '0',
            'height' => '0',
            'date_coll' => '2017-11-10',
        ),
        array(
            'pick_code' => '14300',
            'pick_state' => 'nt',
            'pick_country' => 'MY',
            'send_code' => '81100',
            'send_state' => 'jhr',
            'send_country' => 'MY',
            'weight' => '10',
            'width' => '0',
            'length' => '0',
            'height' => '0',
            'date_coll' => '2017-11-10',
        ),
    ),
);

$url = $domain.$action;
$ch = curl_init();
curl_setopt($ch, CURLOPT_URL, $url);
curl_setopt($ch, CURLOPT_POST, 1);
curl_setopt($ch, CURLOPT_POSTFIELDS, http_build_query($postparam));
curl_setopt($ch, CURLOPT_HEADER, 0);
curl_setopt($ch, CURLOPT_RETURNTRANSFER, TRUE);

ob_start();
$return = curl_exec($ch);
ob_end_clean();
curl_close($ch);

$json = json_decode($return);
echo "<pre>"; print_r($json); echo "</pre>";
?>
```

### cURL

```bash
curl -X POST 'https://demo.connect.easyparcel.my/?ac=MPNormalRateCheckingBulk' \
  --data-urlencode 'authentication=xxxxxx' \
  --data-urlencode 'api=xxxxxx' \
  --data-urlencode 'bulk[0][pick_code]=14300' \
  --data-urlencode 'bulk[0][pick_state]=nt' \
  --data-urlencode 'bulk[0][pick_country]=MY' \
  --data-urlencode 'bulk[0][send_code]=81100' \
  --data-urlencode 'bulk[0][send_state]=jhr' \
  --data-urlencode 'bulk[0][send_country]=MY' \
  --data-urlencode 'bulk[0][weight]=10' \
  --data-urlencode 'bulk[0][width]=0' \
  --data-urlencode 'bulk[0][length]=0' \
  --data-urlencode 'bulk[0][height]=0' \
  --data-urlencode 'bulk[0][date_coll]=2017-11-10' \
  --data-urlencode 'bulk[1][pick_code]=14300' \
  --data-urlencode 'bulk[1][pick_state]=nt' \
  --data-urlencode 'bulk[1][pick_country]=MY' \
  --data-urlencode 'bulk[1][send_code]=81100' \
  --data-urlencode 'bulk[1][send_state]=jhr' \
  --data-urlencode 'bulk[1][send_country]=MY' \
  --data-urlencode 'bulk[1][weight]=10' \
  --data-urlencode 'bulk[1][width]=0' \
  --data-urlencode 'bulk[1][length]=0' \
  --data-urlencode 'bulk[1][height]=0' \
  --data-urlencode 'bulk[1][date_coll]=2017-11-10'
```

## Response

### Response L1

| Field | Type | Description | Remarks |
| --- | --- | --- | --- |
| `api_status` | string(10) | Validation result | (Refer to [Appendix I](https://developers.easyparcel.com/my/marketplace/appendix/api-return-status.md)) |
| `error_code` | int(5) | Error code | (Refer to [Appendix I](https://developers.easyparcel.com/my/marketplace/appendix/api-return-status.md)) |
| `error_remark` | string(100) | Error message | (Refer to [Appendix I](https://developers.easyparcel.com/my/marketplace/appendix/api-return-status.md)) |
| `result` | array | Result of rate checking | (Refer to [Response L2](#response-l2)) |

### Response L2 · `result` {#response-l2}

| Field | Type | Description | Remarks |
| --- | --- | --- | --- |
| `status` | string(10) | The status of the rate checking. | Fail / Success |
| `remarks` | string(100) | The error message for rate checking. |  |
| `rates` | array | The response of the rate checking | (Refer to [Response L3](#response-l3)) |

### Response L3 · `rates` {#response-l3}

| Field | Type | Description | Remarks |
| --- | --- | --- | --- |
| `member_rate` | array | The result member rate checking. | (Refer to [Response L4](#response-l4)) |
| `non_member_rate` | array | The result non-member rate checking. | (Refer to [Response L4](#response-l4)) |

### Response L4 · `member_rate` / `non_member_rate` {#response-l4}

| Field | Type | Description | Remarks |
| --- | --- | --- | --- |
| `service_id` | string (15) | Service ID |  |
| `service_name` | string (100) | Service name |  |
| `service_type` | string (10) | Type of service | parcel/ document |
| `courier_id` | string (10) | Courier ID |  |
| `courier_name` | string (100) | Courier name |  |
| `courier_logo` | string (300) | Courier logo |  |
| `scheduled_start_date` | string (50) | Scheduled pickup for parcel. |  |
| `pickup_date` | date | The date to pickup the parcel. | Same day pickup only available before 12pm. |
| `delivery` | string (100) | The day(s) to deliver the parcel. |  |
| `price` | double (8,2) | Booking price. |  |

## Response samples

### Success

```json
{
  "api_status":"Success",
  "error_code":"0",
  "error_remark":"",
  "result":[
    {
      "status":"Success",
      "remarks":"",
      "rates":{
        "member_rate":[
          {
            "service_id":"EP-CS0W",
            "service_name":"Next Day Delivery Service",
            "service_type":"parcel",
            "courier_id":"EP-CR05",
            "courier_name":"Skynet",
            "courier_logo":"http:\/\/cp.easyparcel.my\/v1\/include\/theme_1\/source\/img\/logo\/\/images\/partners\/Skynet_Express_(M)_Sdn_Bhd.png",
            "scheduled_start_date":"2017-11-10 Friday",
            "pickup_date":"2017-11-10",
            "delivery":"Estimated 1 working day(s)",
            "price":"19.90"
          },
          {
            "service_id":"EP-CS04",
            "service_name":"Next Day Delivery Service",
            "service_type":"parcel",
            "courier_id":"EP-CR0M",
            "courier_name":"Nationwide",
            "courier_logo":"http:\/\/cp.easyparcel.my\/v1\/include\/theme_1\/source\/img\/logo\/\/images\/partners\/Nationwide_Express_Courier_Services_Berhad.png",
            "scheduled_start_date":"2017-11-10 Friday",
            "pickup_date":"2017-11-10",
            "delivery":"Estimated 1 working day(s)",
            "price":"20.70"
          },
          {
            "service_id":"EP-CS0A2",
            "service_name":"Same Day Poslaju Pick up (within PM)",
            "service_type":"parcel",
            "courier_id":"EP-CR0A",
            "courier_name":"Poslaju",
            "courier_logo":"http:\/\/cp.easyparcel.my\/v1\/include\/theme_1\/source\/img\/logo\/\/images\/partners\/POSLAJU_NATIONAL_COURIER.png",
            "scheduled_start_date":"2017-11-10 Friday",
            "pickup_date":"2017-11-10",
            "delivery":"Estimated 1 working day(s)",
            "price":"64.00"
          }
        ],
        "non_member_rate":[
          {
            "service_id":"EP-CS0W",
            "service_name":"Next Day Delivery Service",
            "service_type":"parcel",
            "courier_id":"EP-CR05",
            "courier_name":"Skynet",
            "courier_logo":"http:\/\/cp.easyparcel.my\/v1\/include\/theme_1\/source\/img\/logo\/\/images\/partners\/Skynet_Express_(M)_Sdn_Bhd.png",
            "scheduled_start_date":"2017-11-10 Friday",
            "pickup_date":"2017-11-10",
            "delivery":"Estimated 1 working day(s)",
            "price":"36.00"
          },
          {
            "service_id":"EP-CS04",
            "service_name":"Next Day Delivery Service",
            "service_type":"parcel",
            "courier_id":"EP-CR0M",
            "courier_name":"Nationwide",
            "courier_logo":"http:\/\/cp.easyparcel.my\/v1\/include\/theme_1\/source\/img\/logo\/\/images\/partners\/Nationwide_Express_Courier_Services_Berhad.png",
            "scheduled_start_date":"2017-11-10 Friday",
            "pickup_date":"2017-11-10",
            "delivery":"Estimated 1 working day(s)",
            "price":"37.20"
          },
          {
            "service_id":"EP-CS0A2",
            "service_name":"Same Day Poslaju Pick up (within PM)",
            "service_type":"parcel",
            "courier_id":"EP-CR0A",
            "courier_name":"Poslaju",
            "courier_logo":"http:\/\/cp.easyparcel.my\/v1\/include\/theme_1\/source\/img\/logo\/\/images\/partners\/POSLAJU_NATIONAL_COURIER.png",
            "scheduled_start_date":"2017-11-10 Friday",
            "pickup_date":"2017-11-10",
            "delivery":"Estimated 1 working day(s)",
            "price":"83.20"
          }
        ]
      }
    },
    {
      "status":"Success",
      "remarks":"",
      "rates":{
        "member_rate":[
          {
            "service_id":"EP-CS0W",
            "service_name":"Next Day Delivery Service",
            "service_type":"parcel",
            "courier_id":"EP-CR05",
            "courier_name":"Skynet",
            "courier_logo":"http:\/\/cp.easyparcel.my\/v1\/include\/theme_1\/source\/img\/logo\/\/images\/partners\/Skynet_Express_(M)_Sdn_Bhd.png",
            "scheduled_start_date":"2017-11-10 Friday",
            "pickup_date":"2017-11-10",
            "delivery":"Estimated 1 working day(s)",
            "price":"19.90"
          },
          {
            "service_id":"EP-CS04",
            "service_name":"Next Day Delivery Service",
            "service_type":"parcel",
            "courier_id":"EP-CR0M",
            "courier_name":"Nationwide",
            "courier_logo":"http:\/\/cp.easyparcel.my\/v1\/include\/theme_1\/source\/img\/logo\/\/images\/partners\/Nationwide_Express_Courier_Services_Berhad.png",
            "scheduled_start_date":"2017-11-10 Friday",
            "pickup_date":"2017-11-10",
            "delivery":"Estimated 1 working day(s)",
            "price":"20.70"
          },
          {
            "service_id":"EP-CS0A2",
            "service_name":"Same Day Poslaju Pick up (within PM)",
            "service_type":"parcel",
            "courier_id":"EP-CR0A",
            "courier_name":"Poslaju",
            "courier_logo":"http:\/\/cp.easyparcel.my\/v1\/include\/theme_1\/source\/img\/logo\/\/images\/partners\/POSLAJU_NATIONAL_COURIER.png",
            "scheduled_start_date":"2017-11-10 Friday",
            "pickup_date":"2017-11-10",
            "delivery":"Estimated 1 working day(s)",
            "price":"64.00"
          }
        ],
        "non_member_rate":[
          {
            "service_id":"EP-CS0W",
            "service_name":"Next Day Delivery Service",
            "service_type":"parcel",
            "courier_id":"EP-CR05",
            "courier_name":"Skynet",
            "courier_logo":"http:\/\/cp.easyparcel.my\/v1\/include\/theme_1\/source\/img\/logo\/\/images\/partners\/Skynet_Express_(M)_Sdn_Bhd.png",
            "scheduled_start_date":"2017-11-10 Friday",
            "pickup_date":"2017-11-10",
            "delivery":"Estimated 1 working day(s)",
            "price":"36.00"
          },
          {
            "service_id":"EP-CS04",
            "service_name":"Next Day Delivery Service",
            "service_type":"parcel",
            "courier_id":"EP-CR0M",
            "courier_name":"Nationwide",
            "courier_logo":"http:\/\/cp.easyparcel.my\/v1\/include\/theme_1\/source\/img\/logo\/\/images\/partners\/Nationwide_Express_Courier_Services_Berhad.png",
            "scheduled_start_date":"2017-11-10 Friday",
            "pickup_date":"2017-11-10",
            "delivery":"Estimated 1 working day(s)",
            "price":"37.20"
          },
          {
            "service_id":"EP-CS0A2",
            "service_name":"Same Day Poslaju Pick up (within PM)",
            "service_type":"parcel",
            "courier_id":"EP-CR0A",
            "courier_name":"Poslaju",
            "courier_logo":"http:\/\/cp.easyparcel.my\/v1\/include\/theme_1\/source\/img\/logo\/\/images\/partners\/POSLAJU_NATIONAL_COURIER.png",
            "scheduled_start_date":"2017-11-10 Friday",
            "pickup_date":"2017-11-10",
            "delivery":"Estimated 1 working day(s)",
            "price":"83.20"
          }
        ]
      }
    }
  ]
}
```

### Fail

```json
{
  "api_status":"Error",
  "error_code":"1",
  "error_remark":"Required authentication key",
  "result":[
    
  ]
}
```

## Referenced appendices

Copied from the appendix pages linked above.

### Appendix I: API Return Status

Source: https://developers.easyparcel.com/my/marketplace/appendix/api-return-status.md

| api_status | error_code | error_remark | Explanation |
| --- | --- | --- | --- |
| Success | 0 |  |  |
| Error | 1 | Required authentication key | Missing authentication param |
| Error | 2 | Invalid authentication key |  |
| Error | 3 | Required api key | Missing API key param |
| Error | 4 | Invalid api key |  |
| Error | 5 | Unauthorized user | Invalid API key |
| Error | 6 | Required bulk array |  |
| Error | 7 | Required bulk data insert format in array |  |
| Error | 8 | Invalid account |  |
| Error | 9 | Unverified account. Please kindly verify your account at easyparcel.com |  |
| Error | 1000 | Missing / Invalid Parameter | If a required parameter is missing or an invalid value is entered, the error will be displayed in the error_detail field. |
| Error | 1002 | Invalid User Account | The user does not have a wallet associated with the relevant country. |
| Error | 1003 | Invalid parcel category, you should refer to Get Parcel Category API | Invalid parcel category, you should refer to Get Parcel Category API |
| Error | 1004 | Invalid collection/ delivery postcode |  |
| Error | 1005 | Invalid collection/delivery state | If the value is "Pulau Penang," an error will occur because our system only accepts state codes. |
| Error | 1006 | Invalid courier | Incorrect Courier code |
| Error | 3001 | Shipment insured | This tracking number has previously purchased insurance through EasyParcel, cannot buy insurance again |
| Error | 3002 | Shipment delivered | The status of this tracking number shipment is "delivered", not allow to buy insurance |
| Error | 3003 | Not under claim coverage | The courier insurance provides coverage for parcel contents up to RM200. However, since you entered a parcel content value of RM100, it does not qualify for claim coverage. |
| Error | 3004 | Only support international/domestic shipment | For example, Fedex only supports international shipments to buy insurance |
| Error | 3005 | No Cover | If the collection state or delivery location is not within the insurance coverage area, an error message along with a description will be displayed. |
| Error | 9999 | Unknown error | If this error occurs, please contact our support team for assistance. |

Support: WhatsApp EasyParcel API Support — https://api.whatsapp.com/send/?phone=6042023160

Published by EasyParcel Sdn Bhd (1028666-H).
